package com.persagy.entity;

import com.alibaba.fastjson.JSONObject;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * 要下发的定时指令、手动指令及结果(command_result)实体类
 *
 * @author lixing
 * @since 2020-09-10 15:54:33
 * @description 由 Mybatisplus Code Generator 创建
 */
@Data
@NoArgsConstructor
@Accessors(chain = true)
public class CommandResult implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
	private String id;
    /**
     * projectId
     */
    private String projectId;
    /**
     * 功能号
     */
    private String funcId;
    /**
     * 表号id
     */
    private String meterId;
    /**
     * 执行指令的时间，手动时为空
     */
    private String commandTime;
    /**
     * 指令执行结果,0-成功；1-失败；2-超时不响应
     */
    private Integer commandResult;
    /**
     * createTime
     */
    private Date createTime;
    /**
     * updateTime
     */
	private Date updateTime;
    /**
     * 扩展字段
     */
    private String remark;
    /**
     * 信息点要执行的指令
     */
    private String pointAction;
    /**
     * 对象id
     */
    private String objectId;

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }

}