package com.persagy.job;

import com.alibaba.fastjson.JSONObject;
import com.persagy.client.GroupNettyClient;
import com.persagy.entity.AlarmState;
import com.persagy.entity.CommandResult;
import com.persagy.entity.NettyMessage;
import com.persagy.utils.DateUtils;
import com.persagy.utils.StringUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.quartz.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.quartz.QuartzJobBean;

import java.util.concurrent.atomic.AtomicLong;

@DisallowConcurrentExecution
@PersistJobDataAfterExecution
@Slf4j
public class AlarmExpireJob extends QuartzJobBean {

    @Autowired
    private GroupNettyClient groupNettyClient;

    private String alarmStateString;

    private AtomicLong nums = new AtomicLong(1L);

    @Override
    protected void executeInternal(JobExecutionContext context) throws JobExecutionException {
        try {
            JobDataMap mergedJobDataMap = context.getMergedJobDataMap();
            log.info("------------------");
            if(StringUtils.isNotBlank(alarmStateString)) {
                AlarmState alarmState = StringUtil.tranferItemToDTO(this.alarmStateString, AlarmState.class);
                log.info("报警恢复参数为：",alarmState.toString());
//                groupNettyClient.sendMessage();
            }
        } catch (Exception e) {
            log.error("job hander error",e);
        }

    }

    public String getAlarmStateString() {
        return alarmStateString;
    }

    public void setAlarmStateString(String alarmStateString) {
        this.alarmStateString = alarmStateString;
    }
}
