package com.persagy.utils;

import cn.hutool.core.date.DateUtil;
import org.springframework.stereotype.Service;

import java.util.concurrent.Executor;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

/**
 * @description:
 * @author:LuoGuangyi
 * @company:PersagyTechnologyCo.,Ltd
 * @since:2020/10/19 00199:26
 * @version:V1.0
 **/
@Service
public class LockUtil {
    static Lock lock = new ReentrantLock();
    static Condition condition = lock.newCondition();
    private static volatile boolean execute = true;
    AtomicInteger num = new AtomicInteger(0);
    public static boolean isExecute() {
        return execute;
    }

    public static void setExecute(boolean execute) {
        LockUtil.execute = execute;
    }

    public void await() throws InterruptedException {
        System.out.println("----------");
        ExecutorService executorService = Executors.newFixedThreadPool(5);
        for (int j = 0; j < 20; j++) {
            executorService.execute(()->{
                for (int i = 0; i < 10000; i++) {
                    try {
                        Thread.sleep(1000);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    if(LockUtil.isExecute()){
                        System.out.println(num.getAndIncrement());
                    }else {
                        lock.lock();
                        try {
                            System.out.println(DateUtil.now()+"等待");
                            try {
                                condition.await();
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                            }
                            System.out.println(DateUtil.now()+"["+Thread.currentThread().getName()+"]"+"等待执行"+num.getAndIncrement());
                        }finally {
                            lock.unlock();
                        }

                    }
                }
            });
        }


        Executors.newScheduledThreadPool(1).scheduleAtFixedRate(()->{
            lock.lock();
            try {
                LockUtil.setExecute(!LockUtil.isExecute());
                //加个等待，保证正在执行的逻辑执行成功
                Thread.sleep(2000);
                if(LockUtil.isExecute()){
                    condition.signalAll();
                }
            } catch (InterruptedException e) {
                e.printStackTrace();
            } finally {
                lock.unlock();
            }

        },0,5, TimeUnit.SECONDS);
    }

}
